/*
 * Copyright (C) 2000  Transmeta Corporation
 *
 * written by Claudio Fleiner <cfl@transmeta.com>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#include "busybox.h"
#include <grp.h>
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>

#if defined BB_SU
const char su_usage[] =
        "su uid gid command\n"
#ifndef BB_FEATURE_TRIVIAL_HELP
        "\nExecute a command with the given uid/gid.\n"
#endif
        ;
#endif

/*
 * switch from root to a numeric user/group id.
 * and execute the remaining arguments in a shell.
 * This is a cheap replacement for su to drop root.
 * Never install it suid root!
 */
int su_main(int argc,char **argv) {
        int gid=0,uid=0;
        if(argc<4) usage(su_usage);
        gid=atoi(argv[2]);
        uid=atoi(argv[1]);

        if(setregid(gid,gid) < 0) perror("setregid");
        if(setgroups(1,&gid) < 0) perror("setgroups");
        if(setreuid(uid,uid) < 0) perror("setreuid");
        return execvp(argv[3],argv+3);
}
